From e1331be07812900c9bee7525547b046120ab2329 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Bastien=20ROUCARI=C3=88S?= <roucaries.bastien@gmail.com>
Date: Tue, 14 Mar 2017 15:05:53 +0100
Subject: [PATCH 2/7] Use DPKG_ROOT for symlink to dir

---
 scripts/dpkg-maintscript-helper.sh | 30 +++++++++++++++++-------------
 1 file changed, 17 insertions(+), 13 deletions(-)

diff --git a/scripts/dpkg-maintscript-helper.sh b/scripts/dpkg-maintscript-helper.sh
index e0e66f921..4cf7f04eb 100755
--- a/scripts/dpkg-maintscript-helper.sh
+++ b/scripts/dpkg-maintscript-helper.sh
@@ -280,10 +280,10 @@ symlink_to_dir() {
 	case "$DPKG_MAINTSCRIPT_NAME" in
 	preinst)
 		if [ "$1" = "install" -o "$1" = "upgrade" ] &&
-		   [ -n "$2" ] && [ -h "$SYMLINK" ] &&
+		   [ -n "$2" ] && [ -h "${DPKG_ROOT}$SYMLINK" ] &&
 		   symlink_match "$SYMLINK" "$SYMLINK_TARGET" &&
 		   dpkg --compare-versions -- "$2" le-nl "$LASTVERSION"; then
-			mv -f "$SYMLINK" "${SYMLINK}.dpkg-backup"
+			mv -f "${DPKG_ROOT}$SYMLINK" "${DPKG_ROOT}${SYMLINK}.dpkg-backup"
 		fi
 		;;
 	postinst)
@@ -291,23 +291,23 @@ symlink_to_dir() {
 		# know what was the last configured version, and we might
 		# have been unpacked, then upgraded with an unpack and thus
 		# never been configured before.
-		if [ "$1" = "configure" ] && [ -h "${SYMLINK}.dpkg-backup" ] &&
+		if [ "$1" = "configure" ] && [ -h "${DPKG_ROOT}${SYMLINK}.dpkg-backup" ] &&
 		   symlink_match "${SYMLINK}.dpkg-backup" "$SYMLINK_TARGET"
 		then
-			rm -f "${SYMLINK}.dpkg-backup"
+			rm -f "${DPKG_ROOT}${SYMLINK}.dpkg-backup"
 		fi
 		;;
 	postrm)
-		if [ "$1" = "purge" ] && [ -h "${SYMLINK}.dpkg-backup" ]; then
-		    rm -f "${SYMLINK}.dpkg-backup"
+		if [ "$1" = "purge" ] && [ -h "${DPKG_ROOT}${SYMLINK}.dpkg-backup" ]; then
+		    rm -f "${DPKG_ROOT}${SYMLINK}.dpkg-backup"
 		fi
 		if [ "$1" = "abort-install" -o "$1" = "abort-upgrade" ] &&
 		   [ -n "$2" ] &&
-		   [ ! -e "$SYMLINK" ] && [ -h "${SYMLINK}.dpkg-backup" ] &&
+		   [ ! -e "${DPKG_ROOT}$SYMLINK" ] && [ -h "${DPKG_ROOT}${SYMLINK}.dpkg-backup" ] &&
 		   symlink_match "${SYMLINK}.dpkg-backup" "$SYMLINK_TARGET" &&
 		   dpkg --compare-versions -- "$2" le-nl "$LASTVERSION"; then
 			echo "Restoring backup of $SYMLINK ..."
-			mv "${SYMLINK}.dpkg-backup" "$SYMLINK"
+			mv "${DPKG_ROOT}${SYMLINK}.dpkg-backup" "${DPKG_ROOT}$SYMLINK"
 		fi
 		;;
 	*)
@@ -519,11 +519,15 @@ ensure_package_owns_file() {
 
 symlink_match()
 {
-	local SYMLINK="$1"
-	local SYMLINK_TARGET="$2"
-
-	[ "$(readlink "$SYMLINK")" = "$SYMLINK_TARGET" ] || \
-	[ "$(readlink -f "$SYMLINK")" = "$SYMLINK_TARGET" ]
+         local SYMLINK="$1"
+	 local SYMLINK_TARGET="$2"
+	 local DPKG_ROOT_CANON=""
+         if [ -n $DPKG_ROOT ]; then
+	     DPKG_ROOT_CANON="$(readlink -f "$DPKG_ROOT")"
+	 fi
+
+	 [ "$(readlink "$SYMLINK")" = "$SYMLINK_TARGET" ] || \
+	 [ "$(readlink -f "${DPKG_ROOT_CANON}$SYMLINK")" = "${DPKG_ROOT_CANON}$SYMLINK_TARGET" ]
 }
 
 debug() {
-- 
2.11.0

